unit LibMapaSms2;

interface

uses
//  IdHTTP, IdURI, mshtml, ActiveX, COMObj,
//  IdMultipartFormData,
  URLMon, ShellApi,
  SysUtils,
  StdCtrls;

const
  keyvalid = #8' 1234567890abcdefghijklmmnopqrstuvwxyzABCDEFGHIJKLMMNOPQRSTUVWXYZ,.!?;:@#$%&*()^-+_=/|'#10#13;
  ace = '';
  noa = 'ACEIOUAEIOUAEIOUAOEUaceiouaeiouaeiouaoeu';

function getSaldoMes(auth:String):String;

function setSms(auth,destino,sms:String):String;

function ValidCountCaracters(var msg:string): Integer;

implementation

uses Classes;

const
  urlsms = 'http://sms.mapainformatica.com.br/';

//function URLEncode(const S: string; const InQueryString: Boolean = True): string;
//var
//  Idx: Integer; // loops thru characters in string
//begin
//  Result := '';
//  for Idx := 1 to Length(S) do
//  begin
//    case S[Idx] of
//      'A'..'Z', 'a'..'z', '0'..'9', '-', '_', '.':
//        Result := Result + S[Idx];
//      ' ':
//        if InQueryString then
//          Result := Result + '+'
//        else
//          Result := Result + '%20';
//      else
//        Result := Result + '%' + SysUtils.IntToHex(Ord(S[Idx]), 2);
//    end;
//  end;
//end;

function UrlEncode(const DecodedStr: String; Pluses: Boolean = True): String;
var
  I: Integer;
begin
  Result := '';
  if Length(DecodedStr) > 0 then
    for I := 1 to Length(DecodedStr) do
    begin
      if not (DecodedStr[I] in ['0'..'9', 'a'..'z',
                                       'A'..'Z', ' ']) then
        Result := Result + '%' + IntToHex(Ord(DecodedStr[I]), 2)
      else if not (DecodedStr[I] = ' ') then
        Result := Result + DecodedStr[I]
      else
        begin
          if not Pluses then
            Result := Result + '%20'
          else
            Result := Result + '+';
        end;
    end;
end;

function ValidCountCaracters(var msg:string): Integer;
var
  i,t:Integer;
  new:string;
begin
  t:=Length(ace);
  for i:=1 to t do
  begin
    if(Pos(ace[i],msg)>0)then
      msg:=StringReplace(msg,ace[i],noa[i],[rfReplaceAll, rfIgnoreCase]);
  end;
  t:=Length(msg);
  for i:=1 to t do
  begin
    if Pos(msg[i],keyvalid)>0 then
    begin
      new:=new+msg[i];
    end else begin
      //raise Exception.Create('Caracter invalido');
    end;
  end;
  msg:=new;
  new:=StringReplace(new,#13#10,#10,[rfReplaceAll, rfIgnoreCase]);
  new:=StringReplace(new,#13,#10,[rfReplaceAll, rfIgnoreCase]);
  Result := Length(new);
end;

function URLOPEN(AURL,PARAM: string):string;
var
  DestFile:String;
begin
  Result := '';
  PARAM := '?'+FormatDateTime('YYMMDDhhmmsszzz',Now)+'&'+PARAM;
  DestFile := StringReplace(ParamStr(0),'.exe','.tmp',[rfIgnoreCase]);
  DeleteFile(DestFile);
  if(UrlDownloadToFile(nil, PChar(AURL+PARAM), PChar(DestFile), 0, nil) = 0) then
  begin
    with TStringList.Create do
    try
      Text:='';
      if FileExists(DestFile) then
        LoadFromFile(DestFile);
      Result := Text;
    finally
      Free;
      DeleteFile(DestFile);
    end;
  end;
end;

function getSaldoMes(auth:String):String;
var
  URL,PARAM,s : String;
begin
  auth:=Trim(auth);
  if(auth='')then
    raise Exception.Create('favor infomar a chave do cliente');
  URL := urlsms+'balance';
  PARAM := 'auth=' + URLEncode(auth);
  s:=URLOPEN(URL,PARAM);
  Result:=Trim(s);
end;

function setSms(auth,destino,sms:String):String;
var
  URL,PARAM,s,content,resp : String;
begin
  auth:=Trim(auth);
  destino:=Trim(destino);
  if(auth='')then
    raise Exception.Create('Favor infomar a chave do cliente');
  URL := urlsms+'send';
  LibMapaSms2.ValidCountCaracters(sms);
  s:=Trim(sms);
  s:=StringReplace(s,#13#10,#10,[rfReplaceAll, rfIgnoreCase]);
  s:=StringReplace(s,#13,#10,[rfReplaceAll, rfIgnoreCase]);
  if(Length(s)>160)then
    raise Exception.Create('A mensagem tem mais de 160 caracteres. '#13#10+
    'Envie o parametro "SeNecessarioMaisDeUmSms" = True '#13#10+
    'para liberar o envio de mais de um sms se necessario');
  content:=Copy(s,1,160);
  PARAM := 'auth=' + URLEncode(auth);
  PARAM := PARAM + '&mobile=' + URLEncode(destino);
  PARAM := PARAM + '&content=' + URLEncode(content);
  resp:=URLOPEN(URL,PARAM);
  resp:=StringReplace(resp,#13#10,#10,[rfReplaceAll, rfIgnoreCase]);
  resp:=StringReplace(resp,#10,#13#10,[rfReplaceAll, rfIgnoreCase]);
  Result:=Result+resp+#13#10;
  Result:=Trim(Result);
end;

end.

