unit Unit1;

interface

uses
  LibMapaSms2,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    CHAVE: TLabel;
    EditCHAVE: TEdit;
    EditTelefone: TEdit;
    Telefone: TLabel;
    SMS: TLabel;
    MemoSMS: TMemo;
    btnenviar: TButton;
    btn_limpar: TButton;
    btn_saldo: TButton;
    LOG: TLabel;
    MemoLog: TMemo;
    LabelCount: TLabel;
    Memo1: TMemo;
    procedure MemoSMSChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnenviarClick(Sender: TObject);
    procedure btn_limparClick(Sender: TObject);
    procedure btn_saldoClick(Sender: TObject);
    procedure MemoSMSExit(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.MemoSMSChange(Sender: TObject);
var
  s:String;
  i:Integer;
begin
  s:=MemoSMS.Text;
  i:=MemoSMS.SelStart;
  LabelCount.Caption:=
    IntToStr(
      LibMapaSms2.ValidCountCaracters(s)
    );
  MemoSMS.Text:=s;
  MemoSMS.SelStart:=i;  
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  MemoSMSChange(MemoSMS);
end;

procedure TForm1.btnenviarClick(Sender: TObject);
begin
  MemoLog.Text := setSms(
      EditCHAVE.Text,
      EditTelefone.Text,
      MemoSMS.Text
  );
end;

procedure TForm1.btn_limparClick(Sender: TObject);
begin
  MemoLog.Clear;
end;

procedure TForm1.btn_saldoClick(Sender: TObject);
begin
  MemoLog.Text:=getSaldoMes(EditCHAVE.Text);
end;

procedure TForm1.MemoSMSExit(Sender: TObject);
var
  i:Integer;
  s:String;
begin
  s:=MemoSMS.Text;
  i:=MemoSMS.SelStart;
  LabelCount.Caption:=
    IntToStr(
      LibMapaSms2.ValidCountCaracters(s)
    );
  MemoSMS.Text:=s;
  MemoSMS.SelStart:=i;
end;

end.
